"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var path_1 = __importDefault(require("path"));
var fs_1 = require("fs");
var readline_1 = require("readline");
var crypto_1 = __importDefault(require("crypto"));
var credential_provider_node_1 = require("@aws-sdk/credential-provider-node");
var client_polly_1 = require("@aws-sdk/client-polly");
var extractSpeechOutputBlocks_1 = __importDefault(require("./internals/utils/extractSpeechOutputBlocks"));
var readline = (0, readline_1.createInterface)({
    input: process.stdin,
    output: process.stdout,
});
var getSpeechMarksCacheKey = function (speechOutputId) {
    return "".concat(speechOutputId, ".json");
};
var getAudioCacheKey = function (speechOutputId) { return "".concat(speechOutputId, ".mp3"); };
var publicPath = "./public/tts/";
var getHash = function (text) {
    return crypto_1.default
        .createHash("md5")
        .update(text)
        .digest("hex");
};
var hasTextChanged = function (speechMarksJson, freshText) {
    var textHashInFile = speechMarksJson.textHash;
    return getHash(freshText) !== textHashInFile;
};
var generateTtsFiles = function (pluginOptions, speechOutputBlock, cache, reporter) { return __awaiter(void 0, void 0, void 0, function () {
    var client, ssmlTagsBeforeText, ssmlTagsAfterText, ssmlTagsToUse, matches, textWithSsmlTags, pollyBaseConfiguration, mp3Data, audio, jsonData, speechMarks, speechMarksJson, json;
    var _a, _b;
    return __generator(this, function (_c) {
        switch (_c.label) {
            case 0:
                client = new client_polly_1.PollyClient({
                    apiVersion: "2016-06-10",
                    region: pluginOptions.awsRegion,
                    credentials: (0, credential_provider_node_1.defaultProvider)({
                        profile: pluginOptions.awsProfile,
                        mfaCodeProvider: function (mfaSerial) { return __awaiter(void 0, void 0, void 0, function () {
                            return __generator(this, function (_a) {
                                return [2 /*return*/, new Promise(function (resolve) {
                                        readline.question("Enter MFA token for AWS account: ".concat(mfaSerial, "\n"), function (mfaToken) {
                                            readline.close();
                                            resolve(mfaToken);
                                        });
                                    })];
                            });
                        }); },
                    }),
                });
                ssmlTagsBeforeText = "";
                ssmlTagsAfterText = "";
                ssmlTagsToUse = speechOutputBlock.ssmlTags || pluginOptions.defaultSsmlTags;
                if (ssmlTagsToUse) {
                    if (ssmlTagsToUse.indexOf("$SPEECH_OUTPUT_TEXT") === -1) {
                        throw new Error("If the 'defaultSsmlTags' option is defined it must contain the '$SPEECH_OUTPUT_TEXT' variable (see README file).");
                    }
                    matches = ssmlTagsToUse.match(/(.*)\$SPEECH_OUTPUT_TEXT(.*)/);
                    if (!!matches) {
                        ssmlTagsBeforeText = matches[1];
                        ssmlTagsAfterText = matches[2];
                    }
                    else {
                        throw new Error("Invalid 'defaultSsmlTags' option defined. Check README file for more information about the option.");
                    }
                }
                textWithSsmlTags = "<speak>".concat(ssmlTagsBeforeText).concat(speechOutputBlock.text).concat(ssmlTagsAfterText, "</speak>");
                pollyBaseConfiguration = {
                    VoiceId: speechOutputBlock.voiceId || pluginOptions.defaultVoiceId,
                    LexiconNames: speechOutputBlock.lexiconNames || pluginOptions.defaultLexiconNames,
                    TextType: "ssml",
                    Text: textWithSsmlTags,
                };
                reporter.info("(Re-)generating mp3 for SpeechOutput with ID: ".concat(speechOutputBlock.id));
                return [4 /*yield*/, client.send(new client_polly_1.SynthesizeSpeechCommand(__assign({ OutputFormat: "mp3" }, pollyBaseConfiguration)))];
            case 1:
                mp3Data = _c.sent();
                return [4 /*yield*/, ((_a = mp3Data.AudioStream) === null || _a === void 0 ? void 0 : _a.transformToByteArray())];
            case 2:
                audio = _c.sent();
                if (audio) {
                    cache.set(getAudioCacheKey(speechOutputBlock.id), Buffer.from(audio).toString("base64"));
                }
                reporter.info("(Re-)generating speech marks for SpeechOutput with ID: ".concat(speechOutputBlock.id));
                return [4 /*yield*/, client.send(new client_polly_1.SynthesizeSpeechCommand(__assign({ OutputFormat: "json", SpeechMarkTypes: ["word"] }, pollyBaseConfiguration)))];
            case 3:
                jsonData = _c.sent();
                return [4 /*yield*/, ((_b = jsonData.AudioStream) === null || _b === void 0 ? void 0 : _b.transformToString())];
            case 4:
                speechMarks = _c.sent();
                if (speechMarks) {
                    speechMarksJson = JSON.parse("[".concat(speechMarks.replace(/\}\n\{/g, "},{"), "]"));
                    json = {
                        textHash: getHash(speechOutputBlock.text),
                        speechMarks: speechMarksJson,
                    };
                    cache.set(getSpeechMarksCacheKey(speechOutputBlock.id), json);
                }
                return [2 /*return*/];
        }
    });
}); };
var generateFiles = function (speechOutputBlocks, pluginOptions, cache, reporter) { return __awaiter(void 0, void 0, void 0, function () {
    var i, speechOutputBlock, speechMarks, audio, filesAlreadyExist, isGenerationRequired, eventuallyRegeneratedSpeechMarks, eventuallyRegeneratedAudio;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                i = 0;
                _a.label = 1;
            case 1:
                if (!(i < speechOutputBlocks.length)) return [3 /*break*/, 10];
                speechOutputBlock = speechOutputBlocks[i];
                return [4 /*yield*/, cache.get(getSpeechMarksCacheKey(speechOutputBlock.id))];
            case 2:
                speechMarks = _a.sent();
                return [4 /*yield*/, cache.get(getAudioCacheKey(speechOutputBlock.id))];
            case 3:
                audio = _a.sent();
                filesAlreadyExist = speechMarks && audio;
                isGenerationRequired = !filesAlreadyExist || hasTextChanged(speechMarks, speechOutputBlock.text);
                if (pluginOptions.skipRegeneratingIfExistingInPublicFolder &&
                    (0, fs_1.existsSync)(path_1.default.join(publicPath, "".concat(speechOutputBlock.id, ".mp3"))) &&
                    (0, fs_1.existsSync)(path_1.default.join(publicPath, "".concat(speechOutputBlock.id, ".json")))) {
                    reporter.info("Skip regenerating because of 'skipRegeneratingIfExistingInPublicFolder' flag for SpeechOutput with ID: ".concat(speechOutputBlock.id));
                    return [2 /*return*/];
                }
                if (!isGenerationRequired) return [3 /*break*/, 5];
                return [4 /*yield*/, generateTtsFiles(pluginOptions, speechOutputBlock, cache, reporter)];
            case 4:
                _a.sent();
                return [3 /*break*/, 6];
            case 5:
                reporter.info("Skip regenerating unchanged SpeechOutput with ID: ".concat(speechOutputBlock.id));
                _a.label = 6;
            case 6: return [4 /*yield*/, cache.get(getSpeechMarksCacheKey(speechOutputBlock.id))];
            case 7:
                eventuallyRegeneratedSpeechMarks = _a.sent();
                return [4 /*yield*/, cache.get(getAudioCacheKey(speechOutputBlock.id))];
            case 8:
                eventuallyRegeneratedAudio = _a.sent();
                (0, fs_1.mkdirSync)(publicPath, { recursive: true });
                if (eventuallyRegeneratedAudio) {
                    (0, fs_1.writeFileSync)(path_1.default.join(publicPath, "".concat(speechOutputBlock.id, ".mp3")), Buffer.from(eventuallyRegeneratedAudio, "base64"));
                }
                else {
                    reporter.warn("No audio data found in cache for SpeechOutput with ID: ".concat(speechOutputBlock.id));
                }
                if (eventuallyRegeneratedSpeechMarks) {
                    (0, fs_1.writeFileSync)(path_1.default.join(publicPath, "".concat(speechOutputBlock.id, ".json")), JSON.stringify(eventuallyRegeneratedSpeechMarks));
                }
                else {
                    reporter.warn("No speech marks found in cache for SpeechOutput with ID: ".concat(speechOutputBlock.id));
                }
                _a.label = 9;
            case 9:
                i++;
                return [3 /*break*/, 1];
            case 10: return [2 /*return*/];
        }
    });
}); };
module.exports = function (parameters, pluginOptions) { return __awaiter(void 0, void 0, void 0, function () {
    var speechOutputBlocks;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                speechOutputBlocks = (0, extractSpeechOutputBlocks_1.default)(parameters.markdownAST, pluginOptions.speechOutputComponentNames || ["SpeechOutput"], pluginOptions.ignoredCharactersRegex);
                if (!(speechOutputBlocks.length > 0)) return [3 /*break*/, 2];
                return [4 /*yield*/, generateFiles(speechOutputBlocks, pluginOptions, parameters.cache, parameters.reporter)];
            case 1:
                _a.sent();
                _a.label = 2;
            case 2: return [2 /*return*/, parameters.markdownAST];
        }
    });
}); };
// TODO: make sure if a certain text is no longer existing, related files are deleted as well!
//# sourceMappingURL=index.js.map