"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = __importStar(require("react"));
var useSound = function (soundFilePath) {
    var _a = React.useState(false), isPlaying = _a[0], setPlaying = _a[1];
    var soundFileHandle = React.useRef();
    React.useEffect(function () {
        soundFileHandle.current = new Audio(soundFilePath);
        soundFileHandle.current.addEventListener("ended", function () { return setPlaying(false); });
    }, [soundFilePath]);
    React.useEffect(function () {
        if (!soundFileHandle.current) {
            return;
        }
        if (isPlaying) {
            soundFileHandle.current.play();
        }
        else {
            soundFileHandle.current.pause();
            soundFileHandle.current.currentTime = 0;
        }
    }, [isPlaying]);
    React.useEffect(function () {
        return function () {
            if (soundFileHandle.current) {
                soundFileHandle.current.pause();
                soundFileHandle.current.currentTime = 0;
            }
        };
    }, []);
    return [isPlaying, setPlaying];
};
exports.default = useSound;
//# sourceMappingURL=UseSound.js.map