"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var unist_util_visit_1 = __importDefault(require("unist-util-visit"));
var headingBreakTag = "<break time='0.5s'/>";
var paragraphBreakTag = "<break time='1s'/>";
var getChildText = function (node) {
    var textParts = [];
    (0, unist_util_visit_1.default)(node, [
        function (node) {
            return node.type === "text";
        },
    ], function (node) {
        textParts.push(node.value);
    });
    return textParts.join("");
};
var mdastToSsmlString = function (node) {
    var textParts = [];
    (0, unist_util_visit_1.default)(node, [
        function (node) {
            return ["paragraph", "heading"].includes(node.type);
        },
    ], function (node) {
        if (node.type === "paragraph") {
            textParts.push("".concat(getChildText(node)).concat(paragraphBreakTag));
        }
        else if (node.type === "heading") {
            textParts.push("<s>".concat(getChildText(node), "</s>").concat(headingBreakTag));
        }
    });
    return textParts.join("");
};
var getSsmlFromMdxAst = function (mdAst) {
    return mdastToSsmlString(mdAst);
};
exports.default = getSsmlFromMdxAst;
//# sourceMappingURL=getSsmlFromMdxAst.js.map